<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Quoridor</title>
</head>

<body style="margin:0; overflow: hidden; background-color: #f8e3cb ">
    <h1 style="background-color: #f8e3cb; text-align:center; color: rgb(184, 140, 100); font-family:garamond ">QUORIDOR
        GAME
    </h1>
    <p style="background-color: #f8e3cb; text-align:center; color: rgb(184, 140, 100); font-family:georgia">Be the first
        to reach the line
        opposite to one's base line.</p>
    <script>

        var cnv;
        let player1;
        let player2;
        let div1;
        let div2;
        var firstsq;
        let squares = [];
        var gameTable;
        var bw1;
        var bw2;
        var edge1;
        var edge2;
        var fence;
        var tableWidth = 530;
        var tableHeight = 40;

        let shapeX;
        let shapeY;
        const radius = 17.5;
        const diameter = radius * 2;
        let shapeMove = false;

        let shapeX2;
        let shapeY2;
        let shapeMove2 = false;

        var fence1 = [];
        var fence2 = [];
        let shapeMoveFences = false;
        var iFence;

        function setup() {

            cnv = createCanvas(window.innerWidth, window.innerWidth);
            let square = new Square();
            shapeX = 777;
            shapeY = 67;
            shapeX2 = 777;
            shapeY2 = 507;

            let nameInput1 = createInput('');
            nameInput1.position(1250, 150);
            nameInput1.size(100);
            nameInput1.input(getInput1Value);

            let nameInput2 = createInput('');
            nameInput2.position(1250, 250);
            nameInput2.size(100);
            nameInput2.input(getInput2Value);

            var addNameButton1 = createButton('Add First Player');
            addNameButton1.position(1380, 150);
            addNameButton1.style('color: orange');
            addNameButton1.mousePressed(firstPlayerDiv);

            var addNameButton2 = createButton('Add Second Player');
            addNameButton2.position(1380, 250);
            addNameButton2.style('color: orange');
            addNameButton2.mousePressed(secondPlayerDiv);

            var resetButton = createButton('RESET');
            resetButton.position(1250, 450);
            resetButton.style('color: orange');
            resetButton.size(100, 50);
            resetButton.mousePressed(resetGame);
        }

        function changeColor() {
            fill("navy");
        }

        function draw() {
            background("#f8e3cb");

            createTable();
            createSquares();
            boardFences1();
            boardFences2();
            boardEdge1();
            boardEdge2();
            createFencesPl1();
            createFencesPl2();
            createFirstPlayer();
            fill("#F2A19E");
            circle(shapeX, shapeY, diameter);
            createSecondPlayer();
            fill("#EFF29E");
            circle(shapeX2, shapeY2, diameter);
            showFences();
        }

        function mousePressed() {
            let d = dist(mouseX, mouseY, shapeX, shapeY);
            if (d < radius) {
                shapeMove = true;
            } else {
                shapeMove = false;
            }
            let d2 = dist(mouseX, mouseY, shapeX2, shapeY2);
            if (d2 < radius) {
                shapeMove2 = true;
            } else {
                shapeMove2 = false;
            }
            for (var i = 0; i <= 9; i++) {
                
                if(mouseX > fence1[i].x && mouseX < fence1[i].x + fence1[i].w && 
                mouseY > fence1[i].y && mouseY < fence1[i].y + fence1[i].h) {
                    shapeMoveFences = true;
                    iFence = i;
                    console.log(i);
                } 
            }
            for (var i = 0; i <= 9; i++) {
                if(mouseX > fence2[i].x && mouseX < fence2[i].x + fence2[i].w && 
                mouseY > fence2[i].y && mouseY < fence2[i].y + fence2[i].h) { {
                    shapeMoveFences = true;
                    iFence = i;
                }
                }  
            }
        }

        function mouseReleased() {
            shapeMove = false;
            shapeMove2 = false;
            shapeMoveFences = false;
        }

        function mouseDragged() {
            if (shapeMove) {
                shapeX = mouseX;
                shapeY = mouseY;
            }
            if (shapeMove2) {
                shapeX2 = mouseX;
                shapeY2 = mouseY;
            }
            if(shapeMoveFences) {
                console.log(iFence);
                fence1[iFence].x = mouseX;
                fence1[iFence].y = mouseY;
                shapeMoveFences = false;
            }
        }

        function firstPlayerDiv() {
            div1 = createDiv(player1);
            div1.style('font-size', '20px');
            div1.position(1250, 200);
        }

        function getInput1Value() {
            player1 = this.value();
        }

        function secondPlayerDiv() {
            div2 = createDiv(player2);
            div2.style('font-size', '20px');
            div2.position(1250, 300);
        }

        function getInput2Value() {
            player2 = this.value();
        }

        function resetGame() {
            setup();
            player1 = '';
            player2 = '';
            div1.remove();
            div2.remove();
        }

        function createTable() {
            fill("#ECB77B");
            gameTable = rect(tableWidth, tableHeight, 495, 495);
        }

        function boardFences1() {
            fill("#ECB77B");
            bw1 = rect(409, 40, 109, 495);
        }

        function boardFences2() {
            fill("#ECB77B");
            bw2 = rect(1037, 40, 109, 495);
        }

        function boardEdge1() {
            fill("#f2cb9e");
            edge1 = rect(519, 40, 10, 495);
        }

        function boardEdge2() {
            fill("#f2cb9e");
            edge2 = rect(1026, 40, 10, 495);
        }

        function createFencesPl1() {
            fill("#E5A15C");
            var x = 413;
            var y = 0;
            var w = 99;
            var h = 12;
            var nrFences = 0;
            for (var i = 0; nrFences <= 9; i++) {
                rect(x, y = y + 51, w, h);
                fence1.push({
                     x : 413,
                     y : (i + 1)*51,
                     w : 99,
                     h : 12,
                });
                nrFences++;
            }
        }

        this.clicked = function () {
            var d = dist(mouseX, mouseY, x, y);
            if (d < 35) {
                fill("#E5A15C");
            }
        }

        function createFencesPl2() {
            fill("#E5A15C");
            var x = 1041;
            var y = 0;
            var w = 99;
            var h = 12;
            var nrFences = 0;
            for (var i = 0; nrFences <= 9; i++) {
                rect(x, y = y + 51, w, h);
                fence2.push({
                     x : 1041,
                     y : (i + 1 )*51,
                     w : 99,
                     h : 12,
                });
                nrFences++;
            }
        }

        function createFirstPlayer(shapeX, shapeY, diameter) {
            fill("#F2A19E");
            circle(shapeX, shapeY, diameter)
        }

        function createSecondPlayer(shapeX2, shapeY2, diameter) {
            fill("#EFF29E");
            circle(shapeX2, shapeY2, diameter);
        }

        function createSquares() {
            for (y = tableHeight + 5; y < 500; y += 55) {
                for (x = tableWidth + 5; x < 995; x += 55) {
                    fill("#f2cb9e");
                    squares.push(square(x, y, 45));
                }
            }
        }

        function showFences() {
            for (var i = 0; i <= 9; i++) {
                fill("#E5A15C")
                rect(fence1[i].x, fence1[i].y, fence1[i].w, fence1[i].h);         
            }
            for (var i = 0; i <= 9; i++) {
                fill("#E5A15C")
                rect(fence2[i].x, fence2[i].y, fence2[i].w, fence2[i].h);         
            }
        }

    </script>
    <script src="./p5.min.js"></script>
    <script src="./square.js"></script>
</body>

</html>